﻿using System;
using System.Collections.Generic;
using System.Text;
using Tangra.SDK;

namespace Tangra.Addins
{
	public class DemoAddin : ITangraAddin
	{
		private ITangraAddinAction[] m_Addins;
		private LightCurveAddinAction m_AddinAction1;
		private ITangraApplication m_Application;


		private LightCurveAddinAction m_LightCurveAddinAction;
	    private PixelDistributionAction m_GenericAddinAction;
		private AstrometryAction m_AstrometryAddin;

		public DemoAddin()
		{
			m_Addins = new ITangraAddinAction[3];

			m_LightCurveAddinAction = new LightCurveAddinAction();
		    m_GenericAddinAction = new PixelDistributionAction();
			m_AstrometryAddin = new AstrometryAction();

			m_Addins[0] = m_LightCurveAddinAction;
            m_Addins[1] = m_GenericAddinAction;
			m_Addins[2] = m_AstrometryAddin;
		}

		public void Configure()
		{ }

		public string DisplayName
		{
			get { return "Demonstration Add-in"; }
		}
		public string Author
		{
			get { return "Hristo Pavlov"; }
		}

		public string Version
		{
			get { return "1.0"; }
		}

		public string Description
		{
			get { return "Tangra add-in that shows how to implement your own .NET Add-in"; }
		}

		public string Url
		{
			get { return "http://www.hristopavlov.net/Tangra"; }
		}

		public ITangraAddinAction[] GetAddinActions()
		{
			return m_Addins;
		}		

		public void Initialize(ITangraApplication application)
		{
			m_Application = application;
		}

		public void Finalize()
		{ }

		public void OnEventNotification(AddinFiredEventType eventType)
		{
			if (eventType == AddinFiredEventType.LightCurveDataRecomputed)
			{
				m_LightCurveAddinAction.OnLightCurveDataRecomputed();
			}
            else if (eventType == AddinFiredEventType.LightCurveSelectedFrameChanged)
            {
                m_LightCurveAddinAction.OnLightCurveSelectedFrameChanged();
            }
			else if (eventType == AddinFiredEventType.BeginMultiFrameAstrometry)
			{
				m_AstrometryAddin.OnBeginMultiFrameAstrometry();
			}
			else if (eventType == AddinFiredEventType.EndMultiFrameAstrometry)
			{
				m_AstrometryAddin.OnEndMultiFrameAstrometry();
			} 
		}
	}
}
