﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Tangra.SDK;

namespace Tangra.Addins
{
    public class PixelDistributionAction : ITangraAddinAction
    {
        private ITangraApplication m_Application;

        public string DisplayName
        {
            get { return "Pixel Histogram"; }
        }

        public AddinActionType ActionType
        {
            get { return AddinActionType.Generic; }
        }

        public System.Drawing.Bitmap Icon
        {
            get { return Tangra.Addins.Properties.Resources.Icon1.ToBitmap(); }
        }

        public System.Drawing.Color IconTransparentColor
        {
            get { return System.Drawing.Color.Transparent; }
        }

        public void Execute()
        {
        	ITangraOpenedVideo openedVideo = m_Application.GetTangraOpenedVideo();
			if (openedVideo != null)
			{
				var allFrames = new List<Bitmap>();
				uint firstFrame = openedVideo.CurrentFrame;
				uint lastFreme = Math.Min(openedVideo.CurrentFrame + 8, openedVideo.LastFrame);
				for (uint i = firstFrame; i <= lastFreme; i++)
				{
					allFrames.Add(openedVideo.LoadFrame(i));
				}

				frmPixelDistribution frmHistogram = new frmPixelDistribution(allFrames, (int)firstFrame, (int)lastFreme);
				frmHistogram.StartPosition = FormStartPosition.CenterParent;
				frmHistogram.ShowDialog(m_Application.MainWindow);
			}
        }

        public void Initialize(ITangraApplication application)
        {
            m_Application = application;
        }

        public void Finalize()
        { }
    }
}
